﻿--[[
        Give Me Buff:
                Copyright 2009 by MERK, Mileg				
                based on code by Mileg and Stephen Blaising

	Updated 2014 by MERK
		Special thanks go out to GrimGrin
]]

GMBuff_ADDONNAME = "Give Me Buff";
GMBuff_MACRONAME = "GMBuff";

GMBuff_VERSION = "6.0.3d";

CAMPF = "";
CAMPF2 = "";
NoCAMPF = "INV_Misc_QuestionMark";
BFIcon = "Spell_misc_emotionhappy";
GMBuff_Save = {};
local PRIMARYbuff;
local SECONDARYbuff;
local TERTIARYbuff;
local Realm;
local Player;

local GMBuff_UpdateFrame;
local GMBuffUpdate       = {};
GMBuff_UpdateFrame = CreateFrame("Frame")

function GMBuff_OnLoad()

  SlashCmdList["GIVEMEBUFFCOMMAND"] = GMBuff_SlashHandler;
  SLASH_GIVEMEBUFFCOMMAND1 = "/givemebuff";
  SLASH_GIVEMEBUFFCOMMAND2 = "/gmbuff";
  SLASH_GIVEMEBUFFCOMMAND3 = "/gmb";
  
end

function GMBuff_OnEvent(event)
  if (event == "PLAYER_LOGIN") then
    if (GetMacroIndexByName(GMBuff_MACRONAME) == 0) then
      local numGenMacros, numCharMacros = GetNumMacros();
      if (numGenMacros < 36) then
        CreateMacro(GMBuff_MACRONAME, BFIcon, "")
      else
        GMBuff_Print("You have 36 General Macros. Cannot add "..GMBuff_MACRONAME.."!");
      end
    end
    if (GetSpellInfo(COOKFIRE)) then
      CAMPF = "[mod:ctrl] "..COOKFIRE..";";
      CAMPF2 = "[] "..COOKFIRE..";";
    else
      CAMPF = "";
      NoCAMPF = BFIcon;
    end
		GMBuff_UpdateFrame:SetScript("OnUpdate", GMBuff_UpdateFrame_OnUpdate)
  elseif (event == "VARIABLES_LOADED") then
    GMBuff_InitVars();
end
  if event == "BAG_UPDATE" then
		GMBuff_UpdateFrame:SetScript("OnUpdate", GMBuff_UpdateFrame_OnUpdate)
  end
end

function GMBuff_UpdateFrame_OnUpdate(self, elapsed)
local affectingCombat = UnitAffectingCombat("player");
	for i = 0, 11 do
		if GMBuffUpdate[i] then
			GMBuffUpdate[i] = nil
		end
	end
	if GMBuffUpdate.inv then
		GMBuffUpdate.inv = nil
	end
	if(affectingCombat ~= 1) then
	self:SetScript("OnUpdate", nil)
	GMBuff_MakeArray();
    GMBuff_Go();
	end
end

function GMBuff_SlashHandler(msg)
  if (msg) then
    msg = string.lower(msg);
  end
  if (msg == "help") then
    GMBuff_Print(GMBuff_ADDONNAME.." |cff3399CCv"..GMBuff_VERSION.." ");
    GMBuff_Print("Type /macro to open macro list.");
    GMBuff_Print("Drag GMBuff macro to your action bar.");
    GMBuff_Print("Click to eat best buff food.");
    GMBuff_Print("Hold SHIFT and click to eat second best buff food.");
    GMBuff_Print("Hold CTRL and click to create \"Basic Campfire\".");
    GMBuff_Print("/gmb will display the current buff order.");
    GMBuff_Print("/gmb b1=[BUFFTYPE] will update the first buff used in sorting the GMBuff macro.");
    GMBuff_Print("/gmb b2=[BUFFTYPE] will update the second buff used in sorting the GMBuff macro.");
    GMBuff_Print("/gmb b3=[BUFFTYPE] will update the third buff used in sorting the GMBuff macro.");
    GMBuff_Print("Replace [BUFFTYPE] with the following:");
    GMBuff_Print("    agi for Agility");
    GMBuff_Print("    atk for Attack Power");
    GMBuff_Print("    crt for Critical Strike Rating");
    GMBuff_Print("    dod for Dodge");
    GMBuff_Print("    exp for Expertise");
-- Feast
    GMBuff_Print("    has for Haste");
--    GMBuff_Print("    hp5 for Health Per 5");
    GMBuff_Print("    hit for Hit Rating");
    GMBuff_Print("    int for Intellect");
    GMBuff_Print("    mas for Mastery");
    GMBuff_Print("    mp5 for Mana Per 5");
    GMBuff_Print("    mul for Multistrike");
    GMBuff_Print("    oth for Other (miscellaneous)");
    GMBuff_Print("    res for Resistance");
    GMBuff_Print("    spl for Spell Power");
    GMBuff_Print("    spi for Spirit");
    GMBuff_Print("    sta for Stamina");
    GMBuff_Print("    str for Strength");
    GMBuff_Print("    use for Useful");
    GMBuff_Print("    ver for Versatility");

  elseif (msg == "") then
    GMBuff_Print("Buff Food Order");
    GMBuff_Print("First Choice: "..PRIMARYbuff);
    GMBuff_Print("Second Choice: "..SECONDARYbuff);
    GMBuff_Print("Third Choice: "..TERTIARYbuff);

  elseif (msg == "b1=mul") then
    PRIMARYbuff = "Multistrike";
    GMBuff_Print("Primary Buff set to Multistrike");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=mul") then
    SECONDARYbuff = "Multistrike";
    GMBuff_Print("Secondary Buff set to Multistrike");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=mul") then
    TERTIARYbuff = "Multistrike";
    GMBuff_Print("Tertiary Buff set to Multistrike");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();

  elseif (msg == "b1=ver") then
    PRIMARYbuff = "Versatility";
    GMBuff_Print("Primary Buff set to Multistrike");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=ver") then
    SECONDARYbuff = "Versatility";
    GMBuff_Print("Secondary Buff set to Multistrike");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=ver") then
    TERTIARYbuff = "Versatility";
    GMBuff_Print("Tertiary Buff set to Multistrike");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
    
    elseif (msg == "b1=use") then
    PRIMARYbuff = "Useful";
    GMBuff_Print("Primary Buff set to Useful");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=use") then
    SECONDARYbuff = "Useful";
    GMBuff_Print("Secondary Buff set to Useful");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=use") then
    TERTIARYbuff = "Useful";
    GMBuff_Print("Tertiary Buff set to Useful");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=agi") then
    PRIMARYbuff = "Agility";
    GMBuff_Print("Primary Buff set to Agility");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=agi") then
    SECONDARYbuff = "Agility";
    GMBuff_Print("Secondary Buff set to Agility");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=agi") then
    TERTIARYbuff = "Agility";
    GMBuff_Print("Tertiary Buff set to Agility");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
	elseif (msg == "b1=dod") then
    PRIMARYbuff = "Dodge";
    GMBuff_Print("Primary Buff set to Dodge");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=dod") then
    SECONDARYbuff = "Dodge";
    GMBuff_Print("Secondary Buff set to Dodge");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=dod") then
    TERTIARYbuff = "Dodge";
    GMBuff_Print("Tertiary Buff set to Dodge");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=atk") then
    PRIMARYbuff = "Attack Power";
    GMBuff_Print("Primary Buff set to Attack Power");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=atk") then
    SECONDARYbuff = "Attack Power";
    GMBuff_Print("Secondary Buff set to Attack Power");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=atk") then
    TERTIARYbuff = "Attack Power";
    GMBuff_Print("Tertiary Buff set to Attack Power");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=crt") then
    PRIMARYbuff = "Critical Strike Rating";
    GMBuff_Print("Primary Buff set to Critical Strike");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=crt") then
    SECONDARYbuff = "Critical Strike Rating";
    GMBuff_Print("Secondary Buff set to Critical Strike");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=crt") then
    TERTIARYbuff = "Critical Strike Rating";
    GMBuff_Print("Tertiary Buff set to Critical Strike");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=exp") then
    PRIMARYbuff = "Expertise";
    GMBuff_Print("Primary Buff set to Expertise");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=exp") then
    SECONDARYbuff = "Expertise";
    GMBuff_Print("Secondary Buff set to Expertise");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=exp") then
    TERTIARYbuff = "Expertise";
    GMBuff_Print("Tertiary Buff set to Expertise");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=has") then
    PRIMARYbuff = "Haste";
    GMBuff_Print("Primary Buff set to Haste");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=has") then
    SECONDARYbuff = "Haste";
    GMBuff_Print("Secondary Buff set to Haste");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=has") then
    TERTIARYbuff = "Haste";
    GMBuff_Print("Tertiary Buff set to Haste");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=hp5") then
    PRIMARYbuff = "Health Per 5";
    GMBuff_Print("Primary Buff set to Health per 5");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=hp5") then
    SECONDARYbuff = "Health Per 5";
    GMBuff_Print("Secondary Buff set to Health per 5");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=hp5") then
    TERTIARYbuff = "Health Per 5";
    GMBuff_Print("Tertiary Buff set to Health per 5");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=hit") then
    PRIMARYbuff = "Hit Rating";
    GMBuff_Print("Primary Buff set to Hit Rating");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=hit") then
    SECONDARYbuff = "Hit Rating";
    GMBuff_Print("Secondary Buff set to Hit Rating");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=hit") then
    TERTIARYbuff = "Hit Rating";
    GMBuff_Print("Tertiary Buff set to Hit Rating");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=int") then
    PRIMARYbuff = "Intellect";
    GMBuff_Print("Primary Buff set to Intellect");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=int") then
    SECONDARYbuff = "Intellect";
    GMBuff_Print("Secondary Buff set to Intellect");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=int") then
    TERTIARYbuff = "Intellect";
    GMBuff_Print("Tertiary Buff set to Intellect");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=mas") then
    PRIMARYbuff = "Mastery";
    GMBuff_Print("Primary Buff set to Mastery");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=mas") then
    SECONDARYbuff = "Mastery";
    GMBuff_Print("Secondary Buff set to Mastery");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=mas") then
    TERTIARYbuff = "Mastery";
    GMBuff_Print("Tertiary Buff set to Mastery");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=mp5") then
    PRIMARYbuff = "Mana Per 5";
    GMBuff_Print("Primary Buff set to Mana per 5");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=mp5") then
    SECONDARYbuff = "Mana Per 5";
    GMBuff_Print("Secondary Buff set to Mana per 5");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=mp5") then
    TERTIARYbuff = "Mana Per 5";
    GMBuff_Print("Tertiary Buff set to Mana per 5");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=oth") then
    PRIMARYbuff = "Other";
    GMBuff_Print("Primary Buff set to Other");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=oth") then
    SECONDARYbuff = "Other";
    GMBuff_Print("Secondary Buff set to Other");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=oth") then
    TERTIARYbuff = "Other";
    GMBuff_Print("Tertiary Buff set to Other");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=res") then
    PRIMARYbuff = "Resistance";
    GMBuff_Print("Primary Buff set to Resistance");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=res") then
    SECONDARYbuff = "Resistance";
    GMBuff_Print("Secondary Buff set to Resistance");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=res") then
    TERTIARYbuff = "Resistance";
    GMBuff_Print("Tertiary Buff set to Resistance");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=spl") then
    PRIMARYbuff = "Spell Power";
    GMBuff_Print("Primary Buff set to Spell Power");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=spl") then
    SECONDARYbuff = "Spell Power";
    GMBuff_Print("Secondary Buff set to Spell Power");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=spl") then
    TERTIARYbuff = "Spell Power";
    GMBuff_Print("Tertiary Buff set to Spell Power");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=spi") then
    PRIMARYbuff = "Spirit";
    GMBuff_Print("Primary Buff set to Spirit");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=spi") then
    SECONDARYbuff = "Spirit";
    GMBuff_Print("Secondary Buff set to Spirit");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=spi") then
    TERTIARYbuff = "Spirit";
    GMBuff_Print("Tertiary Buff set to Spirit");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=sta") then
    PRIMARYbuff = "Stamina";
    GMBuff_Print("Primary Buff set to Stamina");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=sta") then
    SECONDARYbuff = "Stamina";
    GMBuff_Print("Secondary Buff set to Stamina");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=sta") then
    TERTIARYbuff = "Stamina";
    GMBuff_Print("Tertiary Buff set to Stamina");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=str") then
    PRIMARYbuff = "Strength";
    GMBuff_Print("Primary Buff set to Strength");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=str") then
    SECONDARYbuff = "Strength";
    GMBuff_Print("Secondary Buff set to Strength");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=str") then
    TERTIARYbuff = "Strength";
    GMBuff_Print("Tertiary Buff set to Strength");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  end
end

function GMBuff_Print(msg)
  if ((msg) and (strlen(msg) > 0)) then
    if (DEFAULT_CHAT_FRAME) then
      DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
    end
  end
end

function GMBuff_InitVars()
  
  Player=UnitName("player");
  Realm=GetCVar("realmName");

  if GMBuff_Save[Realm] == nil then
    GMBuff_Save[Realm] = {}
  end

  if GMBuff_Save[Realm][Player] == nil then
    GMBuff_Save[Realm][Player] = {}
  end

  if (GMBuff_Save[Realm][Player].PRIMARYbuff == nil) then
    GMBuff_Save[Realm][Player].PRIMARYbuff = "Useful";
    PRIMARYbuff = "Useful";
  else
    PRIMARYbuff = GMBuff_Save[Realm][Player].PRIMARYbuff;
  end

  if (GMBuff_Save[Realm][Player].SECONDARYbuff == nil) then
    GMBuff_Save[Realm][Player].SECONDARYbuff = "Stamina";
    SECONDARYbuff = "Stamina";
  else
    SECONDARYbuff = GMBuff_Save[Realm][Player].SECONDARYbuff;
  end

  if (GMBuff_Save[Realm][Player].TERTIARYbuff == nil) then
    GMBuff_Save[Realm][Player].TERTIARYbuff = "Critical Strike Rating";
    TERTIARYbuff = "Critical Strike Rating";
  else
    TERTIARYbuff = GMBuff_Save[Realm][Player].TERTIARYbuff;
  end
end

function GMBuff_MakeArray()
  GMBuff_BuffFood = {
[	252	]={	[1]=	"111447"	,[2]=	91	,[3]=	STA	,[4]=	NON	}, --	Talador Surf and Turf
[	251	]={	[1]=	"79320"	,[2]=	90	,[3]=	STA	,[4]=	NON	}, --	Half a Lovely Apple
[	250	]={	[1]=	"111439"	,[2]=	91	,[3]=	STA	,[4]=	NON	}, --	Steamed Scorpion
[	249	]={	[1]=	"111449"	,[2]=	91	,[3]=	CRT	,[4]=	NON	}, --	Blackrock Barbecue
[	248	]={	[1]=	"111450"	,[2]=	91	,[3]=	HAS	,[4]=	NON	}, --	Frosty Stew
[	247	]={	[1]=	"111452"	,[2]=	91	,[3]=	MAS	,[4]=	NON	}, --	Sleeper Surprise
[	246	]={	[1]=	"111453"	,[2]=	91	,[3]=	MUL	,[4]=	NON	}, --	Calamari Crepes
[	245	]={	[1]=	"111454"	,[2]=	91	,[3]=	VER	,[4]=	NON	}, --	Gorgrond Chowder
[	244	]={	[1]=	"44838"	,[2]=	1	,[3]=	ATK	,[4]=	STA	}, --	Slow-Roasted Turkey
[	243	]={	[1]=	"116407"	,[2]=	1	,[3]=	ATK	,[4]=	STA	}, --	Slow-Smoked Turkey
[	242	]={	[1]=	"44836"	,[2]=	1	,[3]=	CRT	,[4]=	NON	}, --	Pumpkin Pie
[	241	]={	[1]=	"44837"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Spice Bread Stuffing
[	240	]={	[1]=	"44839"	,[2]=	1	,[3]=	HAS	,[4]=	NON	}, --	Candied Sweet Potato
[	239	]={	[1]=	"111433"	,[2]=	91	,[3]=	CRT	,[4]=	NON	}, --	Blackrock Ham
[	238	]={	[1]=	"111434"	,[2]=	91	,[3]=	HAS	,[4]=	NON	}, --	Pan-Seared Talbuk
[	237	]={	[1]=	"111436"	,[2]=	91	,[3]=	MAS	,[4]=	NON	}, --	Braised Riverbeast
[	236	]={	[1]=	"111437"	,[2]=	91	,[3]=	MUL	,[4]=	NON	}, --	Rylak Crepes
[	235	]={	[1]=	"111438"	,[2]=	91	,[3]=	VER	,[4]=	NON	}, --	Clefthoof Sausages
[	234	]={	[1]=	"111441"	,[2]=	91	,[3]=	CRT	,[4]=	NON	}, --	Grilled Gulper
[	233	]={	[1]=	"111442"	,[2]=	91	,[3]=	HAS	,[4]=	NON	}, --	Sturgeon Stew
[	232	]={	[1]=	"111444"	,[2]=	91	,[3]=	MAS	,[4]=	NON	}, --	Fat Sleeper Cakes
[	231	]={	[1]=	"111445"	,[2]=	91	,[3]=	MUL	,[4]=	NON	}, --	Fiery Calamari
[	230	]={	[1]=	"111446"	,[2]=	91	,[3]=	VER	,[4]=	NON	}, --	Skulker Chowder
[	229	]={	[1]=	"111457"	,[2]=	91	,[3]=	USE	,[4]=	NON	}, --	Feast of Blood
[	228	]={	[1]=	"111458"	,[2]=	91	,[3]=	USE	,[4]=	NON	}, --	Feast of the Waters
[	227	]={	[1]=	"115300"	,[2]=	90	,[3]=	USE	,[4]=	NON	}, --	Marinated Elekk Steak
[	226	]={	[1]=	"116406"	,[2]=	1	,[3]=	HAS	,[4]=	NON	}, --	Twice-Baked Sweet Potato
[	225	]={	[1]=	"116408"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Herb-Infused Stuffing
[	224	]={	[1]=	"116409"	,[2]=	1	,[3]=	CRT	,[4]=	NON	}, --	Gourmet Pumpkin Pie
[	223	]={	[1]=	"118268"	,[2]=	90	,[3]=	MAS	,[4]=	NON	}, --	Fuzzy Pear
[	222	]={	[1]=	"118270"	,[2]=	90	,[3]=	HAS	,[4]=	NON	}, --	O'ruk Orange
[	221	]={	[1]=	"118272"	,[2]=	90	,[3]=	CRT	,[4]=	NON	}, --	Giant Nagrand Cherry
[	220	]={	[1]=	"118428"	,[2]=	90	,[3]=	USE	,[4]=	NON	}, --	Legion Chili
[	219	]={	[1]=	"120168"	,[2]=	100	,[3]=	VER	,[4]=	NON	}, --	Pre-Mixed Pot of Noodles
[	218	]={	[1]=	"120293"	,[2]=	90	,[3]=	USE	,[4]=	NON	}, --	Lukewarm Yak Roast Broth
[	217	]={	[1]=	"44840"	,[2]=	1	,[3]=	SPL	,[4]=	STA	}, --	Cranberry Chutney
[	216	]={	[1]=	"116405"	,[2]=	1	,[3]=	SPL	,[4]=	STA	}, --	Congealed Cranberry Chutney
[	215	]={	[1]=	"74656"	,[2]=	90	,[3]=	STA	,[4]=	NON	}, --	Chun Tian Spring Rolls
[	214	]={	[1]=	"118269"	,[2]=	90	,[3]=	MUL	,[4]=	NON	}, --	Greenskin Apple
[	213	]={	[1]=	"118271"	,[2]=	90	,[3]=	VER	,[4]=	NON	}, --	Ironpeel Plantain
[	212	]={	[1]=	"118416"	,[2]=	90	,[3]=	USE	,[4]=	NON	}, --	Fish Roe
[	211	]={	[1]=	"62649"	,[2]=	80	,[3]=	STA	,[4]=	USE	}, --	Fortune Cookie
[	210	]={	[1]=	"62661"	,[2]=	80	,[3]=	CRT	,[4]=	STA	}, --	Baked Rockfish
[	209	]={	[1]=	"62662"	,[2]=	80	,[3]=	HIT	,[4]=	STA	}, --	Grilled Dragon
[	208	]={	[1]=	"62663"	,[2]=	80	,[3]=	MAS	,[4]=	STA	}, --	Lavascale Minestrone
[	207	]={	[1]=	"62664"	,[2]=	80	,[3]=	EXP	,[4]=	STA	}, --	Crocolisk Au Gratin
[	206	]={	[1]=	"62665"	,[2]=	80	,[3]=	HAS	,[4]=	STA	}, --	Basilisk Liverdog
[	205	]={	[1]=	"62667"	,[2]=	80	,[3]=	DOD	,[4]=	STA	}, --	Mushroom Sauce Mudfish
[	204	]={	[1]=	"62668"	,[2]=	80	,[3]=	PAR	,[4]=	STA	}, --	Blackbelly Sushi
[	203	]={	[1]=	"62669"	,[2]=	80	,[3]=	AGI	,[4]=	STA	}, --	Skewered Eel
[	202	]={	[1]=	"62671"	,[2]=	80	,[3]=	INT	,[4]=	STA	}, --	Severed Sagefish Head
[	201	]={	[1]=	"70925"	,[2]=	85	,[3]=	AGI	,[4]=	STA	}, --	Eternal Lunar Pear
[	200	]={	[1]=	"70927"	,[2]=	85	,[3]=	STA	,[4]=	STR	}, --	Eternal Sunfruit
[	199	]={	[1]=	"74646"	,[2]=	90	,[3]=	STR	,[4]=	NON	}, --	Black Pepper Ribs and Shrimp
[	198	]={	[1]=	"74648"	,[2]=	90	,[3]=	AGI	,[4]=	NON	}, --	Sea Mist Rice Noodles
[	197	]={	[1]=	"74650"	,[2]=	90	,[3]=	INT	,[4]=	NON	}, --	Mogu Fish Stew
[	196	]={	[1]=	"74653"	,[2]=	90	,[3]=	SPI	,[4]=	NON	}, --	Steamed Crab Surprise
[	195	]={	[1]=	"86073"	,[2]=	90	,[3]=	HIT	,[4]=	NON	}, --	Spicy Salmon
[	194	]={	[1]=	"86074"	,[2]=	90	,[3]=	HAS	,[4]=	NON	}, --	Spicy Vegetable Chips
[	193	]={	[1]=	"101618"	,[2]=	1	,[3]=	USE	,[4]=	NON	}, --	Pandaren Treasure Noodle Soup
[	192	]={	[1]=	"101745"	,[2]=	90	,[3]=	MAS	,[4]=	NON	}, --	Mango Ice
[	191	]={	[1]=	"101746"	,[2]=	90	,[3]=	AGI	,[4]=	NON	}, --	Seasoned Pomfruit Slices
[	190	]={	[1]=	"101747"	,[2]=	90	,[3]=	SPI	,[4]=	NON	}, --	Farmer's Delight
[	189	]={	[1]=	"101748"	,[2]=	90	,[3]=	INT	,[4]=	NON	}, --	Spiced Blossom Soup
[	188	]={	[1]=	"69187"	,[2]=	1	,[3]=	AGI	,[4]=	NON	}, --	Murloc Female Mask
[	187	]={	[1]=	"69188"	,[2]=	1	,[3]=	AGI	,[4]=	NON	}, --	Murloc Male Mask
[	186	]={	[1]=	"69189"	,[2]=	1	,[3]=	INT	,[4]=	NON	}, --	Naga Female Mask
[	185	]={	[1]=	"69190"	,[2]=	1	,[3]=	INT	,[4]=	NON	}, --	Naga Male Mask
[	184	]={	[1]=	"69192"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Ogre Female Mask
[	183	]={	[1]=	"69193"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Ogre Male Mask
[	182	]={	[1]=	"69194"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Vrykul Female Mask
[	181	]={	[1]=	"69195"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Vrykul Male Mask
[	180	]={	[1]=	"74647"	,[2]=	87	,[3]=	AGI	,[4]=	NON	}, --	Valley Stir Fry
[	179	]={	[1]=	"74649"	,[2]=	87	,[3]=	INT	,[4]=	NON	}, --	Braised Turtle
[	178	]={	[1]=	"86069"	,[2]=	87	,[3]=	HAS	,[4]=	NON	}, --	Rice Pudding
[	177	]={	[1]=	"86070"	,[2]=	87	,[3]=	HIT	,[4]=	NON	}, --	Wildfowl Ginseng Soup
[	176	]={	[1]=	"88388"	,[2]=	86	,[3]=	USE	,[4]=	NON	}, --	Squirmy Delight
[	175	]={	[1]=	"88586"	,[2]=	88	,[3]=	USE	,[4]=	NON	}, --	Chao Cookies
[	174	]={	[1]=	"101617"	,[2]=	1	,[3]=	USE	,[4]=	NON	}, --	Deluxe Noodle Soup
[	173	]={	[1]=	"74642"	,[2]=	85	,[3]=	STR	,[4]=	NON	}, --	Charbroiled Tiger Steak
[	172	]={	[1]=	"74643"	,[2]=	85	,[3]=	AGI	,[4]=	NON	}, --	Sauteed Carrots
[	171	]={	[1]=	"74644"	,[2]=	85	,[3]=	INT	,[4]=	NON	}, --	Swirling Mist Soup
[	170	]={	[1]=	"101616"	,[2]=	1	,[3]=	USE	,[4]=	NON	}, --	Noodle Soup
[	169	]={	[1]=	"44791"	,[2]=	1	,[3]=	STA	,[4]=	SPI	}, --	Noblegarden Chocolate
[	168	]={	[1]=	"62651"	,[2]=	80	,[3]=	CRT	,[4]=	STA	}, --	Lightly Fried Lurker
[	167	]={	[1]=	"62652"	,[2]=	80	,[3]=	HIT	,[4]=	STA	}, --	Seasoned Crab
[	166	]={	[1]=	"62653"	,[2]=	80	,[3]=	MAS	,[4]=	STA	}, --	Salted Eye
[	165	]={	[1]=	"62654"	,[2]=	80	,[3]=	HAS	,[4]=	STA	}, --	Lavascale Fillet
[	164	]={	[1]=	"62655"	,[2]=	80	,[3]=	HAS	,[4]=	STA	}, --	Broiled Mountain Trout
[	163	]={	[1]=	"62657"	,[2]=	80	,[3]=	DOD	,[4]=	STA	}, --	Lurker Lunch
[	162	]={	[1]=	"62658"	,[2]=	80	,[3]=	AGI	,[4]=	STA	}, --	Tender Baked Turtle
[	161	]={	[1]=	"62660"	,[2]=	80	,[3]=	INT	,[4]=	STA	}, --	Pickled Guppy
[	160	]={	[1]=	"89592"	,[2]=	60	,[3]=	INT	,[4]=	NON	}, --	Serpent Brew of Meditation
[	159	]={	[1]=	"89594"	,[2]=	80	,[3]=	INT	,[4]=	NON	}, --	Serpent Brew of Serenity
[	158	]={	[1]=	"89599"	,[2]=	60	,[3]=	AGI	,[4]=	NON	}, --	Tiger Brew of Meditation
[	157	]={	[1]=	"89601"	,[2]=	80	,[3]=	AGI	,[4]=	NON	}, --	Tiger Brew of Serenity
[	156	]={	[1]=	"21023"	,[2]=	55	,[3]=	STA	,[4]=	NON	}, --	Dirge's Kickin' Chimaerok Chops
[	155	]={	[1]=	"81410"	,[2]=	90	,[3]=	CRT	,[4]=	NON	}, --	Green Curry Fish
[	154	]={	[1]=	"81413"	,[2]=	90	,[3]=	CRT	,[4]=	NON	}, --	Skewered Peanut Chicken
[	153	]={	[1]=	"81414"	,[2]=	90	,[3]=	MAS	,[4]=	NON	}, --	Pearl Milk Tea
[	152	]={	[1]=	"89591"	,[2]=	50	,[3]=	INT	,[4]=	NON	}, --	Serpent Brew of Pilgrimage
[	151	]={	[1]=	"89598"	,[2]=	50	,[3]=	AGI	,[4]=	NON	}, --	Tiger Brew of Pilgrimage
[	150	]={	[1]=	"94535"	,[2]=	90	,[3]=	MAS	,[4]=	NON	}, --	Grilled Dinosaur Haunch
[	149	]={	[1]=	"98121"	,[2]=	90	,[3]=	HAS	,[4]=	NON	}, --	Amberseed Bun
[	148	]={	[1]=	"98122"	,[2]=	90	,[3]=	HAS	,[4]=	NON	}, --	Camembert du Clefthoof
[	147	]={	[1]=	"98123"	,[2]=	90	,[3]=	CRT	,[4]=	NON	}, --	Whale Shark Caviar
[	146	]={	[1]=	"98124"	,[2]=	90	,[3]=	PAR	,[4]=	NON	}, --	Bloodberry Tart
[	145	]={	[1]=	"98125"	,[2]=	90	,[3]=	DOD	,[4]=	NON	}, --	Shaved Zangar Truffles
[	144	]={	[1]=	"98126"	,[2]=	90	,[3]=	CRT	,[4]=	NON	}, --	Mechanopeep Foie Gras
[	143	]={	[1]=	"98127"	,[2]=	90	,[3]=	MAS	,[4]=	NON	}, --	Dented Can of Kaja'Cola
[	142	]={	[1]=	"104339"	,[2]=	90	,[3]=	PAR	,[4]=	NON	}, --	Harmonious River Noodles
[	141	]={	[1]=	"104340"	,[2]=	90	,[3]=	DOD	,[4]=	NON	}, --	Crazy Snake Noodles
[	140	]={	[1]=	"104341"	,[2]=	90	,[3]=	HAS	,[4]=	NON	}, --	Steaming Goat Noodles
[	139	]={	[1]=	"104342"	,[2]=	90	,[3]=	CRT	,[4]=	NON	}, --	Spicy Mushan Noodles
[	138	]={	[1]=	"104343"	,[2]=	90	,[3]=	HAS	,[4]=	NON	}, --	Golden Dragon Noodles
[	137	]={	[1]=	"104344"	,[2]=	90	,[3]=	CRT	,[4]=	NON	}, --	Lucky Mushroom Noodles
[	136	]={	[1]=	"105717"	,[2]=	90	,[3]=	DOD	,[4]=	NON	}, --	Rice-Wine Mushrooms
[	135	]={	[1]=	"105719"	,[2]=	90	,[3]=	CRT	,[4]=	NON	}, --	Brew-Curried Whitefish
[	134	]={	[1]=	"105720"	,[2]=	90	,[3]=	PAR	,[4]=	NON	}, --	Candied Apple
[	133	]={	[1]=	"105721"	,[2]=	90	,[3]=	MAS	,[4]=	NON	}, --	Hot Papaya Milk
[	132	]={	[1]=	"105722"	,[2]=	90	,[3]=	HAS	,[4]=	NON	}, --	Nutty Brew-Bun
[	131	]={	[1]=	"105723"	,[2]=	90	,[3]=	CRT	,[4]=	NON	}, --	Peanut Pork Chops
[	130	]={	[1]=	"105724"	,[2]=	90	,[3]=	HAS	,[4]=	NON	}, --	Fried Cheese Dumplings
[	129	]={	[1]=	"89593"	,[2]=	70	,[3]=	INT	,[4]=	NON	}, --	Serpent Brew of Fallen Blossoms
[	128	]={	[1]=	"89600"	,[2]=	70	,[3]=	AGI	,[4]=	NON	}, --	Tiger Brew of Fallen Blossoms
[	127	]={	[1]=	"34754"	,[2]=	70	,[3]=	ATK	,[4]=	STA	}, --	Mega Mammoth Meal
[	126	]={	[1]=	"34756"	,[2]=	70	,[3]=	CRT	,[4]=	STA	}, --	Spiced Worm Burger
[	125	]={	[1]=	"34757"	,[2]=	70	,[3]=	HAS	,[4]=	STA	}, --	Very Burnt Worg
[	124	]={	[1]=	"34766"	,[2]=	70	,[3]=	ATK	,[4]=	STA	}, --	Poached Northern Sculpin
[	123	]={	[1]=	"34768"	,[2]=	70	,[3]=	CRT	,[4]=	STA	}, --	Spicy Blue Nettlefish
[	122	]={	[1]=	"34769"	,[2]=	70	,[3]=	HAS	,[4]=	STA	}, --	Imperial Manta Steak
[	121	]={	[1]=	"42994"	,[2]=	70	,[3]=	HAS	,[4]=	STA	}, --	Rhinolicious Wormsteak
[	120	]={	[1]=	"42995"	,[2]=	70	,[3]=	CRT	,[4]=	STA	}, --	Hearty Rhino
[	119	]={	[1]=	"42996"	,[2]=	70	,[3]=	HIT	,[4]=	STA	}, --	Snapper Extreme
[	118	]={	[1]=	"42999"	,[2]=	70	,[3]=	AGI	,[4]=	STA	}, --	Blackened Dragonfin
[	117	]={	[1]=	"20452"	,[2]=	45	,[3]=	STR	,[4]=	NON	}, --	Smoked Desert Dumplings
[	116	]={	[1]=	"27651"	,[2]=	55	,[3]=	SPI	,[4]=	STA	}, --	Buzzard Bites
[	115	]={	[1]=	"27655"	,[2]=	55	,[3]=	ATK	,[4]=	SPI	}, --	Ravager Dog
[	114	]={	[1]=	"27662"	,[2]=	55	,[3]=	SPI	,[4]=	STA	}, --	Feltail Delight
[	113	]={	[1]=	"29292"	,[2]=	55	,[3]=	STR	,[4]=	NON	}, --	Helboar Bacon
[	112	]={	[1]=	"30155"	,[2]=	55	,[3]=	SPI	,[4]=	STA	}, --	Clam Bar
[	111	]={	[1]=	"33867"	,[2]=	55	,[3]=	SPI	,[4]=	STA	}, --	Broiled Bloodfin
[	110	]={	[1]=	"89590"	,[2]=	40	,[3]=	INT	,[4]=	NON	}, --	Serpent Brew of Adversity
[	109	]={	[1]=	"89597"	,[2]=	40	,[3]=	AGI	,[4]=	NON	}, --	Tiger Brew of Adversity
[	108	]={	[1]=	"34125"	,[2]=	70	,[3]=	HAS	,[4]=	STA	}, --	Shoveltusk Soup
[	107	]={	[1]=	"34748"	,[2]=	70	,[3]=	ATK	,[4]=	STA	}, --	Mammoth Meal
[	106	]={	[1]=	"34750"	,[2]=	70	,[3]=	CRT	,[4]=	STA	}, --	Worm Delight
[	105	]={	[1]=	"34751"	,[2]=	70	,[3]=	HAS	,[4]=	STA	}, --	Roasted Worg
[	104	]={	[1]=	"34762"	,[2]=	70	,[3]=	ATK	,[4]=	STA	}, --	Grilled Sculpin
[	103	]={	[1]=	"34764"	,[2]=	70	,[3]=	CRT	,[4]=	STA	}, --	Poached Nettlefish
[	102	]={	[1]=	"42942"	,[2]=	70	,[3]=	HAS	,[4]=	STA	}, --	Baked Manta Ray
[	101	]={	[1]=	"43268"	,[2]=	70	,[3]=	ATK	,[4]=	SPL	}, --	Dalaran Clam Chowder
[	100	]={	[1]=	"89589"	,[2]=	30	,[3]=	INT	,[4]=	NON	}, --	Initiate's Serpent Brew
[	99	]={	[1]=	"89596"	,[2]=	30	,[3]=	AGI	,[4]=	NON	}, --	Initiate's Tiger Brew
[	98	]={	[1]=	"27657"	,[2]=	55	,[3]=	SPI	,[4]=	SPL	}, --	Blackened Basilisk
[	97	]={	[1]=	"27658"	,[2]=	55	,[3]=	SPI	,[4]=	STR	}, --	Roasted Clefthoof
[	96	]={	[1]=	"27659"	,[2]=	55	,[3]=	AGI	,[4]=	SPI	}, --	Warp Burger
[	95	]={	[1]=	"27660"	,[2]=	55	,[3]=	SPI	,[4]=	STA	}, --	Talbuk Steak
[	94	]={	[1]=	"27664"	,[2]=	55	,[3]=	AGI	,[4]=	SPI	}, --	Grilled Mudfish
[	93	]={	[1]=	"27665"	,[2]=	55	,[3]=	SPI	,[4]=	SPL	}, --	Poached Bluefish
[	92	]={	[1]=	"27666"	,[2]=	55	,[3]=	SPI	,[4]=	SPL	}, --	Golden Fish Sticks
[	91	]={	[1]=	"27667"	,[2]=	55	,[3]=	SPI	,[4]=	STA	}, --	Spicy Crawdad
[	90	]={	[1]=	"30357"	,[2]=	65	,[3]=	SPI	,[4]=	SPL	}, --	Oronok's Tuber of Healing
[	89	]={	[1]=	"30358"	,[2]=	65	,[3]=	AGI	,[4]=	SPI	}, --	Oronok's Tuber of Agility
[	88	]={	[1]=	"30359"	,[2]=	65	,[3]=	SPI	,[4]=	STR	}, --	Oronok's Tuber of Strength
[	87	]={	[1]=	"30361"	,[2]=	65	,[3]=	SPI	,[4]=	SPL	}, --	Oronok's Tuber of Spell Power
[	86	]={	[1]=	"31672"	,[2]=	55	,[3]=	SPI	,[4]=	STA	}, --	Mok'Nathal Shortribs
[	85	]={	[1]=	"31673"	,[2]=	55	,[3]=	SPI	,[4]=	SPL	}, --	Crunchy Serpent
[	84	]={	[1]=	"32721"	,[2]=	55	,[3]=	SPI	,[4]=	STA	}, --	Skyguard Rations
[	83	]={	[1]=	"33052"	,[2]=	65	,[3]=	SPI	,[4]=	STA	}, --	Fisherman's Feast
[	82	]={	[1]=	"34411"	,[2]=	65	,[3]=	SPI	,[4]=	STA	}, --	Hot Apple Cider
[	81	]={	[1]=	"43572"	,[2]=	70	,[3]=	OTH	,[4]=	NON	}, --	Magic Eater
[	80	]={	[1]=	"12215"	,[2]=	35	,[3]=	SPI	,[4]=	STA	}, --	Heavy Kodo Stew
[	79	]={	[1]=	"12216"	,[2]=	40	,[3]=	SPI	,[4]=	STA	}, --	Spiced Chili Crab
[	78	]={	[1]=	"12218"	,[2]=	40	,[3]=	SPI	,[4]=	STA	}, --	Monster Omelet
[	77	]={	[1]=	"16971"	,[2]=	40	,[3]=	SPI	,[4]=	STA	}, --	Clamlette Surprise
[	76	]={	[1]=	"17222"	,[2]=	35	,[3]=	SPI	,[4]=	STA	}, --	Spider Sausage
[	75	]={	[1]=	"18045"	,[2]=	40	,[3]=	SPI	,[4]=	STA	}, --	Tender Wolf Steak
[	74	]={	[1]=	"35563"	,[2]=	45	,[3]=	ATK	,[4]=	NON	}, --	Charred Bear Kabobs
[	73	]={	[1]=	"81400"	,[2]=	85	,[3]=	HAS	,[4]=	NON	}, --	Pounded Rice Cake
[	72	]={	[1]=	"81402"	,[2]=	85	,[3]=	CRT	,[4]=	NON	}, --	Toasted Fish Jerky
[	71	]={	[1]=	"81404"	,[2]=	85	,[3]=	DOD	,[4]=	NON	}, --	Dried Needle Mushrooms
[	70	]={	[1]=	"90457"	,[2]=	85	,[3]=	MAS	,[4]=	NON	}, --	Mah's Warm Yak-Tail Stew
[	69	]={	[1]=	"43492"	,[2]=	1	,[3]=	OTH	,[4]=	NON	}, --	Haunted Herring
[	68	]={	[1]=	"43491"	,[2]=	1	,[3]=	OTH	,[4]=	NON	}, --	Bad Clams
[	67	]={	[1]=	"27663"	,[2]=	55	,[3]=	MP5	,[4]=	STA	}, --	Blackened Sporefish
[	66	]={	[1]=	"89588"	,[2]=	20	,[3]=	INT	,[4]=	NON	}, --	Novice's Serpent Brew
[	65	]={	[1]=	"89595"	,[2]=	20	,[3]=	AGI	,[4]=	NON	}, --	Novice's Tiger Brew
[	64	]={	[1]=	"43490"	,[2]=	1	,[3]=	OTH	,[4]=	NON	}, --	Tasty Cupcake
[	63	]={	[1]=	"3728"	,[2]=	25	,[3]=	SPI	,[4]=	STA	}, --	Tasty Lion Steak
[	62	]={	[1]=	"3729"	,[2]=	25	,[3]=	SPI	,[4]=	STA	}, --	Soothing Turtle Bisque
[	61	]={	[1]=	"4457"	,[2]=	25	,[3]=	SPI	,[4]=	STA	}, --	Barbecued Buzzard Wing
[	60	]={	[1]=	"6038"	,[2]=	25	,[3]=	SPI	,[4]=	STA	}, --	Giant Clam Scorcho
[	59	]={	[1]=	"12210"	,[2]=	25	,[3]=	SPI	,[4]=	STA	}, --	Roast Raptor
[	58	]={	[1]=	"12212"	,[2]=	25	,[3]=	SPI	,[4]=	STA	}, --	Jungle Stew
[	57	]={	[1]=	"12213"	,[2]=	25	,[3]=	SPI	,[4]=	STA	}, --	Carrion Surprise
[	56	]={	[1]=	"12214"	,[2]=	25	,[3]=	SPI	,[4]=	STA	}, --	Mystery Stew
[	55	]={	[1]=	"13851"	,[2]=	25	,[3]=	SPI	,[4]=	STA	}, --	Hot Wolf Ribs
[	54	]={	[1]=	"20074"	,[2]=	25	,[3]=	SPI	,[4]=	STA	}, --	Heavy Crocolisk Stew
[	53	]={	[1]=	"24539"	,[2]=	55	,[3]=	SPI	,[4]=	NON	}, --	Marsh Lichen
[	52	]={	[1]=	"64641"	,[2]=	25	,[3]=	SPI	,[4]=	STA	}, --	\"Delicious\" Worm Steak
[	51	]={	[1]=	"43488"	,[2]=	1	,[3]=	OTH	,[4]=	NON	}, --	Last Week's Mammoth
[	50	]={	[1]=	"21217"	,[2]=	30	,[3]=	MP5	,[4]=	NON	}, --	Sagefish Delight
[	49	]={	[1]=	"43001"	,[2]=	70	,[3]=	OTH	,[4]=	NON	}, --	Tracker Snacks
[	48	]={	[1]=	"1017"	,[2]=	15	,[3]=	SPI	,[4]=	STA	}, --	Seasoned Wolf Kabob
[	47	]={	[1]=	"1082"	,[2]=	15	,[3]=	SPI	,[4]=	STA	}, --	Redridge Goulash
[	46	]={	[1]=	"3663"	,[2]=	15	,[3]=	SPI	,[4]=	STA	}, --	Murloc Fin Soup
[	45	]={	[1]=	"3664"	,[2]=	15	,[3]=	SPI	,[4]=	STA	}, --	Crocolisk Gumbo
[	44	]={	[1]=	"3665"	,[2]=	15	,[3]=	SPI	,[4]=	STA	}, --	Curiously Tasty Omelet
[	43	]={	[1]=	"3666"	,[2]=	15	,[3]=	SPI	,[4]=	STA	}, --	Gooey Spider Cake
[	42	]={	[1]=	"3726"	,[2]=	15	,[3]=	SPI	,[4]=	STA	}, --	Big Bear Steak
[	41	]={	[1]=	"3727"	,[2]=	15	,[3]=	SPI	,[4]=	STA	}, --	Hot Lion Chops
[	40	]={	[1]=	"5479"	,[2]=	15	,[3]=	SPI	,[4]=	STA	}, --	Crispy Lizard Tail
[	39	]={	[1]=	"5480"	,[2]=	15	,[3]=	SPI	,[4]=	STA	}, --	Lean Venison
[	38	]={	[1]=	"5527"	,[2]=	15	,[3]=	SPI	,[4]=	STA	}, --	Goblin Deviled Clams
[	37	]={	[1]=	"12209"	,[2]=	15	,[3]=	SPI	,[4]=	STA	}, --	Lean Wolf Steak
[	36	]={	[1]=	"42997"	,[2]=	70	,[3]=	OTH	,[4]=	NON	}, --	Blackened Worg Steak
[	35	]={	[1]=	"21072"	,[2]=	10	,[3]=	MP5	,[4]=	NON	}, --	Smoked Sagefish
[	34	]={	[1]=	"37452"	,[2]=	65	,[3]=	OTH	,[4]=	NON	}, --	Fatty Bluefin
[	33	]={	[1]=	"724"	,[2]=	5	,[3]=	SPI	,[4]=	STA	}, --	Goretusk Liver Pie
[	32	]={	[1]=	"2683"	,[2]=	5	,[3]=	SPI	,[4]=	STA	}, --	Crab Cake
[	31	]={	[1]=	"2684"	,[2]=	5	,[3]=	SPI	,[4]=	STA	}, --	Coyote Steak
[	30	]={	[1]=	"2687"	,[2]=	5	,[3]=	SPI	,[4]=	STA	}, --	Dry Pork Ribs
[	29	]={	[1]=	"3220"	,[2]=	5	,[3]=	SPI	,[4]=	STA	}, --	Blood Sausage
[	28	]={	[1]=	"3662"	,[2]=	5	,[3]=	SPI	,[4]=	STA	}, --	Crocolisk Steak
[	27	]={	[1]=	"5476"	,[2]=	5	,[3]=	SPI	,[4]=	STA	}, --	Fillet of Frenzy
[	26	]={	[1]=	"5477"	,[2]=	5	,[3]=	SPI	,[4]=	STA	}, --	Strider Stew
[	25	]={	[1]=	"5525"	,[2]=	5	,[3]=	SPI	,[4]=	STA	}, --	Boiled Clams
[	24	]={	[1]=	"22645"	,[2]=	5	,[3]=	SPI	,[4]=	STA	}, --	Crunchy Spider Surprise
[	23	]={	[1]=	"27636"	,[2]=	5	,[3]=	SPI	,[4]=	STA	}, --	Bat Bites
[	22	]={	[1]=	"33924"	,[2]=	1	,[3]=	OTH	,[4]=	NON	}, --	Delicious Chocolate Cake
[	21	]={	[1]=	"33866"	,[2]=	55	,[3]=	OTH	,[4]=	NON	}, --	Stormchops
[	20	]={	[1]=	"2680"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Spiced Wolf Meat
[	19	]={	[1]=	"2888"	,[2]=	5	,[3]=	STA	,[4]=	NON	}, --	Beer Basted Boar Ribs
[	18	]={	[1]=	"5472"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Kaldorei Spider Kabob
[	17	]={	[1]=	"5474"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Roasted Kodo Meat
[	16	]={	[1]=	"6888"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Herb Baked Egg
[	15	]={	[1]=	"7806"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Lollipop
[	14	]={	[1]=	"7807"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Candy Bar
[	13	]={	[1]=	"7808"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Chocolate Square
[	12	]={	[1]=	"11584"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Cactus Apple Surprise
[	11	]={	[1]=	"17197"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Gingerbread Cookie
[	10	]={	[1]=	"17198"	,[2]=	1	,[3]=	STA	,[4]=	NON	}, --	Winter Veil Egg Nog
[	9	]={	[1]=	"23756"	,[2]=	5	,[3]=	STA	,[4]=	NON	}, --	Cookie's Jumbo Gumbo
[	8	]={	[1]=	"24105"	,[2]=	4	,[3]=	STA	,[4]=	NON	}, --	Roasted Moongraze Tenderloin
[	7	]={	[1]=	"77264"	,[2]=	1	,[3]=	INT	,[4]=	NON	}, --	Small Bamboo Shoot
[	6	]={	[1]=	"77272"	,[2]=	1	,[3]=	AGI	,[4]=	NON	}, --	Small Sugarcane Stalk
[	5	]={	[1]=	"77273"	,[2]=	1	,[3]=	STR	,[4]=	NON	}, --	Small Rice Cake
[	4	]={	[1]=	"12217"	,[2]=	1	,[3]=	OTH	,[4]=	NON	}, --	Dragonbreath Chili
[	3	]={	[1]=	"32686"	,[2]=	65	,[3]=	OTH	,[4]=	NON	}, --	Mingo's Fortune Giblets
[	2	]={	[1]=	"33924"	,[2]=	1	,[3]=	OTH	,[4]=	NON	}, --	Delicious Chocolate Cake
[	1	]={	[1]=	"6657"	,[2]=	1	,[3]=	OTH	,[4]=	NON	}, --	Savory Deviate Delight
}
end

function GMBuff_Go()
  
  local BuffBFoodRank = 0;
  local BBuffBFoodRank = 0;
  local BuffBFoodItemNum = 0;
  local BBuffBFoodItemNum = 0;
  local oldBFoodItemLink = "Nothing";
  local BoldBFoodItemLink = "Nothing";
  local exact = "no";
  local SECexact = "no";
  local TERexact = "no";
  local primary = "no";
  local secondary = "no";
  local tertiary = "no";

  for bagID = 0, 4, 1 do
    local bagSlotCnt = GetContainerNumSlots(bagID);
    if (bagSlotCnt > 0) then
      for slot = 1, bagSlotCnt, 1 do
        local itemLink = GetContainerItemLink(bagID, slot);
        local itemNumber = GMBuff_NumFromLink(itemLink);
        if (itemNumber) then
          for index = 1, table.getn(GMBuff_BuffFood), 1 do
            if (GMBuff_BuffFood[index][1] == itemNumber) then
              if (GMBuff_BuffFood[index][2] <= UnitLevel("player")) then
                if (((GMBuff_BuffFood[index][3] == PRIMARYbuff) and (GMBuff_BuffFood[index][4] == SECONDARYbuff)) or ((GMBuff_BuffFood[index][3] == SECONDARYbuff) and (GMBuff_BuffFood[index][4] == PRIMARYbuff))) then
                  if ((index > BuffBFoodRank) or (exact == "no")) then
                    BoldBFoodItemLink = oldBFoodItemLink;
                    oldBFoodItemLink = itemLink;
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                    exact = "yes";
                  elseif (((index > BBuffBFoodRank) and (index < BuffBFoodRank)) or (BBuffBFoodItemNum == 0)) then
                    if (index ~= BuffBFoodRank) then
                      BoldBFoodItemLink = itemLink;
                      BBuffBFoodRank = index;
                      BBuffBFoodItemNum = itemNumber;
                    end
                  end
                elseif (((GMBuff_BuffFood[index][3] == PRIMARYbuff) and (GMBuff_BuffFood[index][4] == TERTIARYbuff)) or ((GMBuff_BuffFood[index][3] == TERTIARYbuff) and (GMBuff_BuffFood[index][4] == PRIMARYbuff))) then
                  if (((exact == "no") and (index > BuffBFoodRank)) or ((exact == "no") and (SECexact == "no"))) then
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                    SECexact = "yes";
                  elseif (((exact == "no") and (index > BBuffBFoodRank)  and (index < BuffBFoodRank)) or (BBuffBFoodItemNum == 0)) then
                    if (index ~= BuffBFoodRank) then
                      BBuffBFoodRank = index;
                      BBuffBFoodItemNum = itemNumber;
                    end
                  end
                elseif (((GMBuff_BuffFood[index][3] == SECONDARYbuff) and (GMBuff_BuffFood[index][4] == TERTIARYbuff)) or ((GMBuff_BuffFood[index][3] == TERTIARYbuff) and (GMBuff_BuffFood[index][4] == SECONDARYbuff))) then
                  if (((exact == "no") and (SECexact == "no") and (index > BuffBFoodRank)) or ((exact == "no") and (SECexact == "no") and (TERexact == "no"))) then
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                    TERexact = "yes";
                  elseif (((exact == "no") and (SECexact == "no") and (index > BBuffBFoodRank) and (index < BuffBFoodRank)) or (BBuffBFoodItemNum == 0)) then
                    if (index ~= BuffBFoodRank) then
                      BBuffBFoodRank = index;
                      BBuffBFoodItemNum = itemNumber;
                    end
                  end
                elseif (((GMBuff_BuffFood[index][3] == PRIMARYbuff) or (GMBuff_BuffFood[index][4] == PRIMARYbuff))) then
                  if (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (index > BuffBFoodRank)) or ((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no"))) then
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                    primary = "yes";
                  elseif (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (index > BBuffBFoodRank) and (index < BuffBFoodRank)) or (BBuffBFoodItemNum == 0)) then
                    if (index ~= BuffBFoodRank) then
                    BBuffBFoodRank = index;
                    BBuffBFoodItemNum = itemNumber;
                    end
                  end
                elseif (((GMBuff_BuffFood[index][3] == SECONDARYbuff) or (GMBuff_BuffFood[index][4] == SECONDARYbuff))) then
                  if (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (index > BuffBFoodRank)) or ((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (secondary == "no"))) then
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                    secondary = "yes";
                  elseif (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (index > BBuffBFoodRank) and (index < BuffBFoodRank)) or (BBuffBFoodItemNum == 0)) then
                    if (index ~= BuffBFoodRank) then
                      BBuffBFoodRank = index;
                      BBuffBFoodItemNum = itemNumber;
                    end
                  end
                elseif (((GMBuff_BuffFood[index][3] == TERTIARYbuff) or (GMBuff_BuffFood[index][4] == TERTIARYbuff))) then
                  if (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (secondary == "no") and (index > BuffBFoodRank)) or ((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (secondary == "no") and (tertiary == "no"))) then
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                    tertiary = "yes";
                  elseif (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (secondary == "no") and (index > BBuffBFoodRank) and (index < BuffBFoodRank)) or (BBuffBFoodItemNum == 0)) then
                    if (index ~= BuffBFoodRank) then
                      BBuffBFoodRank = index;
                      BBuffBFoodItemNum = itemNumber;
                    end
                  end
                end
              end
            end
          end
        end
      end
      if (BuffBFoodItemNum == 0) then
        for slot = 1, bagSlotCnt, 1 do
        local itemLink = GetContainerItemLink(bagID, slot);
        local itemNumber = GMBuff_NumFromLink(itemLink);
          if (itemNumber) then
            for index = 1, table.getn(GMBuff_BuffFood), 1 do
              if (GMBuff_BuffFood[index][1] == itemNumber) then
                if (GMBuff_BuffFood[index][2] <= UnitLevel("player")) then
                  if (index > BuffBFoodRank) then
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                  elseif ((index > BBuffBFoodRank) and (index < BuffBFoodRank)) then
                    BBuffBFoodRank = index;
                    BBuffBFoodItemNum = itemNumber;
                  end
                end
              end
            end
          end
        end
      end
    end
  end
  
  if ((BuffBFoodRank > 0) and (BBuffBFoodRank > 0)) then
    EditMacro(GMBuff_MACRONAME, GMBuff_MACRONAME, "INV_Misc_QuestionMark", "#showtooltip\n/use "..CAMPF.." [mod:shift] item:"..BBuffBFoodItemNum.."; [] item:"..BuffBFoodItemNum);
  elseif ((BuffBFoodRank > 0) and (BBuffBFoodRank == 0)) then
    EditMacro(GMBuff_MACRONAME, GMBuff_MACRONAME, "INV_Misc_QuestionMark", "#showtooltip\n/use "..CAMPF.." [] item:"..BuffBFoodItemNum);
  elseif (BuffBFoodRank == 0) then
    EditMacro(GMBuff_MACRONAME, GMBuff_MACRONAME, NoCAMPF, "#showtooltip\n/use "..CAMPF2);
  end
end

function GMBuff_NumFromLink(itemLink)
  if (not itemLink) then
    return nil;
  end
  local _, _, itemNumber = strfind(itemLink, "item:(%d+):");
  return itemNumber;
end
