﻿--[[
        Give Me Bandage:
                Copyright 2009 by MERK, Mileg
                based on code by Mileg and Stephen Blaising

	Updated 2014 by MERK
		Special thanks go out to GrimGrin
]]

GMBandage_ADDONNAME = "Give Me Bandage";
GMBandage_MACRONAME = "GMBandage";

GMBandage_VERSION = "6.0.3d";

FIRSTA = "";
FIRSTA2 = ""
NoFIRSTA = "INV_Misc_QuestionMark";
FAIcon = "Inv_misc_surgeonglove_01";
local GMBandage_ZoneName = "Default";
local GMBandage_ZoneType = "Default";
local GMBandage_UpdateFrame
local GMBandageUpdate       = {}
GMBandage_UpdateFrame = CreateFrame("Frame")


function GMBandage_OnLoad(event)
  SlashCmdList["GIVEMEBANDAGECOMMAND"] = GMBandage_SlashHandler;
  SLASH_GIVEMEBANDAGECOMMAND1 = "/givemebandage";
  SLASH_GIVEMEBANDAGECOMMAND2 = "/gmbandage";
  SLASH_GIVEMEBANDAGECOMMAND3 = "/gmband";
  
end

function GMBandage_OnEvent(event)
  if (event == "PLAYER_LOGIN") then
    if (GetMacroIndexByName(GMBandage_MACRONAME) == 0) then
      local numGenMacros, numCharMacros = GetNumMacros();
      if (numGenMacros < 36) then
        CreateMacro(GMBandage_MACRONAME, FAIcon, "", nil, nil)
      else
        GMBandage_Print("You have 36 General Macros. Cannot add "..GMBandage_MACRONAME.."!");
      end
    end
    if (GetSpellInfo(FAID)) then
      FIRSTA = "[mod:ctrl] "..FAID..";";
      FIRSTA2 = "[] "..FAID..";";
    else
      FIRSTA = "";
      NoFIRSTA = FAIcon;
    end
		GMBandage_UpdateFrame:SetScript("OnUpdate", GMBandage_UpdateFrame_OnUpdate)
  end
  if event == "BAG_UPDATE" then
		GMBandage_UpdateFrame:SetScript("OnUpdate", GMBandage_UpdateFrame_OnUpdate)
  end
end

function GMBandage_UpdateFrame_OnUpdate(self, elapsed)
local affectingCombat = UnitAffectingCombat("player");
	for i = 0, 11 do
		if GMBandageUpdate[i] then
			GMBandageUpdate[i] = nil
		end
	end
	if GMBandageUpdate.inv then
		GMBandageUpdate.inv = nil
	end
		if(affectingCombat ~= 1) then
			self:SetScript("OnUpdate", nil)
			GMBandage_MakeArray();
			GMBandage_Go();
  end

end

function GMBandage_OnUpdate(event)
  if (GMBandage_ZoneName ~= GetRealZoneText()) then
    GMBandage_UpdateFrame:SetScript("OnUpdate", GMBandage_UpdateFrame_OnUpdate)
  end
end

function GMBandage_SlashHandler(msg)
  if (msg) then
    msg = string.lower(msg);
  end
  if (msg == "help" or msg == "") then
    GMBandage_Print(GMBandage_ADDONNAME.." |cff3399CCv"..GMBandage_VERSION.." ");
    GMBandage_Print("Type /macro to open macro list.");
    GMBandage_Print("Drag GMBandage macro to your action bar.");
    GMBandage_Print("Click to use best bandage.");
    GMBandage_Print("Hold ALT and click to use best bandage on self.");
    GMBandage_Print("Hold SHIFT and click to use second best bandage.");
    GMBandage_Print("Hold SHIFT+ALT and click to use second best bandage on self.");
    GMBandage_Print("Hold CTRL and click to open \"First Aid\" tradeskill frame.");
  end
end

function GMBandage_GetZoneType()
  if (GMBandage_ZoneName ~= GetRealZoneText()) then
    GMBandage_ZoneName = GetRealZoneText();
    if ((GMBandage_ZoneName == WSG) or (GMBandage_ZoneName == AV) or (GMBandage_ZoneName == AB) or (GMBandage_ZoneName == EOTS) or (GMBandage_ZoneName == SOTA)) then
      GMBandage_ZoneType = "BG";
	elseif ((GMBandage_ZoneName == TB) or (GMBandage_ZoneName == TBP)) then
      GMBandage_ZoneType = "TB";
    elseif ((GMBandage_ZoneName == BOT) or (GMBandage_ZoneName == EYE) or (GMBandage_ZoneName == MECH) or (GMBandage_ZoneName == ARCA)) then
      GMBandage_ZoneType = "TK";
    elseif ((GMBandage_ZoneName == SSC) or (GMBandage_ZoneName == UB) or (GMBandage_ZoneName == SV) or (GMBandage_ZoneName == SP)) then
      GMBandage_ZoneType = "CFR";
    elseif ((GMBandage_ZoneName == BEM) or (GMBandage_ZoneName == GL)) then
      GMBandage_ZoneType = "BE";
    elseif ((GMBandage_ZoneName == ARENA_BE) or (GMBandage_ZoneName == ARENA_D) or (GMBandage_ZoneName == ARENA_N) or (GMBandage_ZoneName == ARENA_ROL) or (GMBandage_ZoneName == ARENA_ROV)) then
      GMBandage_ZoneType = "ARENA";
    else
      GMBandage_ZoneType = "ALL";
    end
  end
end

function GMBandage_Print(msg)
  if ((msg) and (strlen(msg) > 0)) then
    if (DEFAULT_CHAT_FRAME) then
      DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
    end
  end
end

function GMBandage_MakeArray()
  GMBandage_Bandages = {
[	38	]={	[1]=	"115497"	,[2]=	100	,[3]=	243952	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	ASHRAN BANDAGE
[	37	]={	[1]=	"111603"	,[2]=	91	,[3]=	55288	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	ANTISEPTIC BANDAGE
[	36	]={	[1]=	"72986"	,[2]=	85	,[3]=	9600	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	HEAVY WINDWOOL BANDAGE
[	35	]={	[1]=	"63391"	,[2]=	65	,[3]=	8576	,[4]=	"TB"	,[5]=	"ALL"	}, -- 	BARADIN'S WARDENS BANDAGE
[	34	]={	[1]=	"64995"	,[2]=	65	,[3]=	8576	,[4]=	"TB"	,[5]=	"ALL"	}, -- 	HELLSCREAM'S REACH BANDAGE
[	33	]={	[1]=	"72985"	,[2]=	85	,[3]=	8400	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	WINDWOOL BANDAGE
[	32	]={	[1]=	"53051"	,[2]=	75	,[3]=	7352	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	DENSE EMBERSILK BANDAGE
[	31	]={	[1]=	"53050"	,[2]=	75	,[3]=	6864	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	HEAVY EMBERSILK BANDAGE
[	30	]={	[1]=	"53049"	,[2]=	65	,[3]=	6368	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	EMBERSILK BANDAGE
[	29	]={	[1]=	"34722"	,[2]=	65	,[3]=	5480	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	HEAVY FROSTWEAVE BANDAGE
[	28	]={	[1]=	"35721"	,[2]=	50	,[3]=	4536	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	FROSTWEAVE BANDAGE
[	27	]={	[1]=	"21991"	,[2]=	50	,[3]=	4128	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	HEAVY NETHERWEAVE BANDAGE
[	26	]={	[1]=	"21990"	,[2]=	35	,[3]=	3656	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	NETHERWEAVE BANDAGE
[	25	]={	[1]=	"14530"	,[2]=	0	,[3]=	3384	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	HEAVY RUNECLOTH BANDAGE
[	24	]={	[1]=	"38643"	,[2]=	50	,[3]=	3208	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	THICK FROSTWEAVE BANDAGE
[	23	]={	[1]=	"20243"	,[2]=	45	,[3]=	3064	,[4]=	AB	,[5]=	"ALL"	}, -- 	HIGHLANDER'S RUNECLOTH BANDAGE
[	22	]={	[1]=	"20234"	,[2]=	45	,[3]=	3064	,[4]=	AB	,[5]=	"ALL"	}, -- 	DEFILER'S RUNECLOTH BANDAGE
[	21	]={	[1]=	"20066"	,[2]=	45	,[3]=	3064	,[4]=	AB	,[5]=	"ALL"	}, -- 	ARATHI BASIN RUNECLOTH BANDAGE
[	20	]={	[1]=	"19066"	,[2]=	45	,[3]=	3024	,[4]=	WSG	,[5]=	"ALL"	}, -- 	WARSONG GULCH RUNECLOTH BANDAGE
[	19	]={	[1]=	"14529"	,[2]=	0	,[3]=	2992	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	RUNECLOTH BANDAGE
[	18	]={	[1]=	"20065"	,[2]=	35	,[3]=	2584	,[4]=	AB	,[5]=	"ALL"	}, -- 	ARATHI BASIN MAGEWEAVE BANDAGE
[	17	]={	[1]=	"20232"	,[2]=	35	,[3]=	2584	,[4]=	AB	,[5]=	"ALL"	}, -- 	DEFILER'S MAGEWEAVE BANDAGE
[	16	]={	[1]=	"20237"	,[2]=	35	,[3]=	2584	,[4]=	AB	,[5]=	"ALL"	}, -- 	HIGHLANDER'S MAGEWEAVE BANDAGE
[	15	]={	[1]=	"19067"	,[2]=	35	,[3]=	2392	,[4]=	WSG	,[5]=	"ALL"	}, -- 	WARSONG GULCH MAGEWEAVE BANDAGE
[	14	]={	[1]=	"19307"	,[2]=	0	,[3]=	2392	,[4]=	AV	,[5]=	"ALL"	}, -- 	ALTERAC HEAVY RUNECLOTH BANDAGE
[	13	]={	[1]=	"8545"	,[2]=	0	,[3]=	2391	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	HEAVY MAGEWEAVE BANDAGE
[	12	]={	[1]=	"20244"	,[2]=	25	,[3]=	1552	,[4]=	AB	,[5]=	"ALL"	}, -- 	HIGHLANDER'S SILK BANDAGE
[	11	]={	[1]=	"20235"	,[2]=	25	,[3]=	1552	,[4]=	AB	,[5]=	"ALL"	}, -- 	DEFILER'S SILK BANDAGE
[	10	]={	[1]=	"20067"	,[2]=	25	,[3]=	1552	,[4]=	AB	,[5]=	"ALL"	}, -- 	ARATHI BASIN SILK BANDAGE
[	9	]={	[1]=	"8544"	,[2]=	0	,[3]=	1464	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MAGEWEAVE BANDAGE
[	8	]={	[1]=	"19068"	,[2]=	25	,[3]=	1448	,[4]=	WSG	,[5]=	"ALL"	}, -- 	WARSONG GULCH SILK BANDAGE
[	7	]={	[1]=	"6451"	,[2]=	0	,[3]=	1168	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	HEAVY SILK BANDAGE
[	6	]={	[1]=	"6450"	,[2]=	0	,[3]=	728	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SILK BANDAGE
[	5	]={	[1]=	"3531"	,[2]=	0	,[3]=	546	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	HEAVY WOOL BANDAGE
[	4	]={	[1]=	"3530"	,[2]=	0	,[3]=	294	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	WOOL BANDAGE
[	3	]={	[1]=	"2581"	,[2]=	0	,[3]=	210	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	HEAVY LINEN BANDAGE
[	2	]={	[1]=	"44646"	,[2]=	0	,[3]=	210	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	DALARAN BANDAGE
[	1	]={	[1]=	"1251"	,[2]=	0	,[3]=	120	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	LINEN BANDAGE
}
end

function GMBandage_Go()
  
  local bandageRank = 0;
  local BbandageRank = 0;
  local bandageItemNum = 0;
  local BbandageItemNum = 0;
  local oldBandageItemLink = "Nothing";
  local BoldBandageItemLink = "Nothing";
  
  local Boverride = false
  
  GMBandage_GetZoneType();
  for bagID = 0, 4, 1 do
    local bagSlotCnt = GetContainerNumSlots(bagID);
    if (bagSlotCnt > 0) then
      for slot = 1, bagSlotCnt, 1 do
        local itemLink = GetContainerItemLink(bagID, slot);
        local itemNumber = GMBandage_NumFromLink(itemLink);
        if (itemNumber) then
          for index = 1, #(GMBandage_Bandages), 1 do
            if (GMBandage_Bandages[index][1] == itemNumber) then
              if (GMBandage_Bandages[index][2] <= UnitLevel("player")) then
                if ((GMBandage_Bandages[index][4] == GMBandage_ZoneType) or (GMBandage_Bandages[index][4] == GMBandage_ZoneName) or (GMBandage_Bandages[index][4] == "ALL")) then  
                  if (GMBandage_Bandages[index][4] ~= "ALL") then
                    Boverride = true
                    BoldBandageItemLink = oldBandageItemLink;
                    oldBandageItemLink = itemLink;
                    BbandageRank = bandageRank;
                    bandageRank = GMBandage_Bandages[index][3];
                    BbandageItemNum = bandageItemNum;
                    bandageItemNum = itemNumber;
                  end
                  if ((GMBandage_Bandages[index][3] > bandageRank) and (not Boverride)) then
                    BoldBandageItemLink = oldBandageItemLink;
                    oldBandageItemLink = itemLink;
                    BbandageRank = bandageRank;
                    bandageRank = GMBandage_Bandages[index][3];
                    BbandageItemNum = bandageItemNum;
                    bandageItemNum = itemNumber;
                  elseif ((GMBandage_Bandages[index][3] == bandageRank) and (itemLink ~= oldBandageItemLink) and (not Boverride)) then
                    local oldItemCnt = GetItemCount(oldBandageItemLink);
                    local newItemCnt = GetItemCount(itemLink);
                    if (newItemCnt <= oldItemCnt) then
                      oldBandageItemLink = itemLink;
                      bandageRank = GMBandage_Bandages[index][3];
                      bandageItemNum = itemNumber;
                    end
                  elseif ((GMBandage_Bandages[index][3] < bandageRank) and (GMBandage_Bandages[index][3] > BbandageRank)) then
                    BoldBandageItemLink = itemLink;
                    BbandageRank = GMBandage_Bandages[index][3];
                    BbandageItemNum = itemNumber;
                  elseif ((GMBandage_Bandages[index][3] == BbandageRank) and (itemLink ~= BoldBandageItemLink)) then
                    local oldItemCnt = GetItemCount(BoldBandageItemLink);
                    local newItemCnt = GetItemCount(itemLink);
                    if (newItemCnt <= oldItemCnt) then
                      BoldBandageItemLink = itemLink;
                      BbandageRank = GMBandage_Bandages[index][3];
                      BbandageItemNum = itemNumber;
                    end
                  end
                end
              end  
            end
          end
        end
      end
    end
  end
 			if ((bandageRank > 0) and (BbandageRank > 0)) then
			EditMacro(GMBandage_MACRONAME, GMBandage_MACRONAME, "INV_Misc_QuestionMark", "#showtooltip\n/use "..FIRSTA.." [mod:alt,mod:shift,target=player] item:"..BbandageItemNum.."; [mod:alt,target=player] item:"..bandageItemNum.."; [mod:shift] item:"..BbandageItemNum.."; [] item:"..bandageItemNum, nil, nil);
			elseif ((bandageRank > 0) and (BbandageRank == 0)) then
			EditMacro(GMBandage_MACRONAME, GMBandage_MACRONAME, "INV_Misc_QuestionMark", "#showtooltip\n/use "..FIRSTA.." [mod:alt,target=player] item:"..bandageItemNum.."; [] item:"..bandageItemNum, nil, nil);
			elseif (bandageRank == 0) then
			EditMacro(GMBandage_MACRONAME, GMBandage_MACRONAME, NoFIRSTA, "#showtooltip\n/use "..FIRSTA2, nil, nil);
			end
  
end

function GMBandage_NumFromLink(itemLink)
  if (not itemLink) then
    return nil;
  end
  local _, _, itemNumber = strfind(itemLink, "item:(%d+):");
  return itemNumber;
end
